
#ifndef _PCLINK_H
#define _PCLINK_H

#define TIMEOUT 5               /* receive timeout in seconds */
#define DIRBUFF_L 10000         /* directory buffer length */
                                /* one file takes 32 bytes */
#define true 1
#define false 0

/*--------------------- packet structure -------------------*/
typedef struct
{
  unsigned char headercrc;         /* Header checksum*/
  unsigned char packettype;        /* Packet type */
  unsigned char packetlength;      /* DataLength*/
  unsigned char datacrc;           /* DataPacket CRC*/
  unsigned char packetdata[256];
  int headererr;
} PACKET;

/* --------- packet type: CMD ----------- */
#define cdatatype 0         /* Mark of data-type packet */
#define csendfilecmd 0x1    /* Send file to C64 */
#define cgetfilecmd 0x2     /* Get file from C64 */
#define ccommandcmd 0x3     /* Command packet*/
#define cactivatecmd 0x10   /* Start communication*/

/* --------- packet type: STATUS --------- */
#define cokst 0x80          /* OK*/
#define ceofst 0x81         /* End Of File*/
#define ccommerrst 0x82     /* Communication Error*/
#define copenerrst 0x83     /* File Open Error*/
#define cdeleteerrst 0x84   /* Delete Error*/
#define crenameerrst 0x85   /* Rename Error*/
#define creaderrst 0x86     /* Read Error*/
#define cwriteerrst 0x87    /* Write Error*/
#define ctimeouterrst 0x88  /* TimeOut Error*/
#define ceotst 0x89         /* End of Transmitting*/
#define cunknownerrst 0xff  /* Unknown Error*/

/* --------- communication states --------- */
#define stwaitforaction  0
#define stdetectcmd 1
#define stsendfile0 2
#define stsendfile1 3
#define stsendfile2 4
#define stsendfile3 5
#define stgetfile0 6
#define stgetfile1 7
#define stgetfile2 8
#define stgetfile3 9
#define stmakecommand0 10
#define stmakecommand1 11
#define stsenddir1 12
#define stsenddir2 13 
#define stsenddir3 14

/* ######################################## */

extern int initport(char *,int);
extern void closeport(void);
extern void sendbyte(unsigned char);
extern unsigned char getbyte();

/* --------------- imported --------------- */

extern short timeout;
extern unsigned char timeouterr;

#endif

